The kth great number(小根堆思想,模板题)

简介: The kth great number(小根堆思想,模板题)

Problem Description


Xiao Ming and Xiao Bao are playing a simple Numbers game. In a round Xiao Ming can choose to write down a number, or ask Xiao Bao what the kth great number is. Because the number written by Xiao Ming is too much, Xiao Bao is feeling giddy. Now, try to help Xiao Bao.


Input


There are several test cases. For each test case, the first line of input contains two positive integer n, k. Then n lines follow. If Xiao Ming choose to write down a number, there will be an " I" followed by a number that Xiao Ming will write down. If Xiao Ming choose to ask Xiao Bao, there will be a "Q", then you need to output the kth great number.


Output


The output consists of one integer representing the largest number of islands that all lie on one line.


Sample Input


8 3

I 1

I 2

I 3

Q

I 5

Q

I 4

Q


Sample Output  


1

2

3


题目就是要求我们计算第k大的数,所以我们可以用小根堆的思想;


我们一直保持堆里面由有k个数,那么第k大的数就是堆顶,且一直更新堆,最后更新所有的数之后,我们就可以把堆顶输出 ,就是答案。


听懂了记得给个赞鼓励一下,码字不易,用爱发电。


上ac代码。

f58230e9f063709cf3167704f4efdf14.gif


有事你就q我;QQ2917366383


学习算法

 

  #include<cstdio>
  #include<cstdlib>
  #include<cstring>
  #include<queue>
  #include<iostream>
  #include<algorithm>
  using namespace std;
  int main()
  {
    int n,k,a;
    while(scanf("%d%d",&n,&k)!=EOF)//多组数据输入不影响 
    {
      priority_queue<int ,vector<int>,greater<int> >q; //小根堆,小到大 
      int c=0;//标记堆里面元素个数 
      for(int i=0;i<n;i++)
      {
        char b;
        cin>>b;//输入判断的字符 
        if(b=='I')
        {
          if(c<k)
          {
            scanf("%d",&a);//输入数字 
            c++;
            q.push(a);//放进堆里面 
          }
          else if(c>=k)//如果超过或者等于第k个数 
          {
            scanf("%d",&a);//输入数字
            if(a>q.top())//比较后面输入的数是不是比前面第一个大, 
            {
              q.pop();//把第一个删掉
              q.push(a);//后面的数字放进 堆里面
            }
          }
        }
        else if(b=='Q')//结束条件 
        {
          printf("%d\n",q.top());//输出第一个 
        }
      }   
    } 
  }
相关文章
|
算法
Leetcode 313. Super Ugly Number
题目翻译成中文是『超级丑数』,啥叫丑数?丑数就是素因子只有2,3,5的数,7 14 21不是丑数,因为他们都有7这个素数。 这里的超级丑数只是对丑数的一个扩展,超级丑数的素因子不再仅限于2 3 5,而是由题目给定一个素数数组。与朴素丑数算法相比,只是将素因子变了而已,解法还是和朴素丑数一致的。
99 1
|
5月前
|
存储 SQL 算法
LeetCode 题目 65:有效数字(Valid Number)【python】
LeetCode 题目 65:有效数字(Valid Number)【python】
|
6月前
|
存储 算法
【LeetCode力扣】单调栈解决Next Greater Number(下一个更大值)问题
【LeetCode力扣】单调栈解决Next Greater Number(下一个更大值)问题
45 0
|
存储
Leetcode Single Number II (面试题推荐)
给你一个整数数组,每个元素出现了三次,但只有一个元素出现了一次,让你找出这个数,要求线性的时间复杂度,不使用额外空间。
39 0
|
算法
LeetCode 414. Third Maximum Number
给定一个非空数组,返回此数组中第三大的数。如果不存在,则返回数组中最大的数。要求算法时间复杂度必须是O(n)。
94 0
LeetCode 414. Third Maximum Number
|
存储
LeetCode 313. Super Ugly Number
编写一段程序来查找第 n 个超级丑数。 超级丑数是指其所有质因数都是长度为 k 的质数列表 primes 中的正整数。
97 0
LeetCode 313. Super Ugly Number
|
算法
LeetCode 306. Additive Number
累加数是一个字符串,组成它的数字可以形成累加序列。 一个有效的累加序列必须至少包含 3 个数。除了最开始的两个数以外,字符串中的其他数都等于它之前两个数相加的和。 给定一个只包含数字 '0'-'9' 的字符串,编写一个算法来判断给定输入是否是累加数。 说明: 累加序列里的数不会以 0 开头,所以不会出现 1, 2, 03 或者 1, 02, 3 的情况。
123 0
LeetCode 306. Additive Number
|
算法
LeetCode 268. Missing Number
给定一个包含 0, 1, 2, ..., n 中 n 个数的序列,找出 0 .. n 中没有出现在序列中的那个数。
91 0
LeetCode 268. Missing Number
LeetCode 264. Ugly Number II
编写一个程序,找出第 n 个丑数。 丑数就是只包含质因数 2, 3, 5 的正整数。
72 0
LeetCode 264. Ugly Number II

热门文章

最新文章